<template>
  <div class="ob-left-section">
    <ObTabs
      v-model="selectedTab"
      :items="tabs"
      :no-border="true"
      @on-change-tab="onChangeTab"
    />

    <ObTable
      ref="tasksTable"
      :remoteOpt="{
        method: api.taskMonitor.getTasks,
        arguments: {
          archive: selectedTab.type === 'archive'
        },
        contentKey: 'tasks'
      }"
      :remote-trigger="selectedTab"
      :columns="modifiedColumns"
      :functional-panel="true"
      :is-css-selectable="true"
      :is-functional-group="false"
      :is-functional-sort="false"
      is-fixed-header
      @on-load-list="onTableDataLoaded"
      @select="onSelect"
    >
      <FieldRelevance
        slot="relevance"
        slot-scope="{ data }"
        :data="data"
      />

      <NoneContent
        v-if="!isLoading"
        slot="noneContent"
        :text="`У вас пока нет ${selectedTab.type === 'active' ? 'входящих' : 'выполненных'} задач`"
      />
    </ObTable>
  </div>
</template>

<script>
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObTabs from 'common-components/src/obComponents/obTabs'
  import FieldRelevance from './FieldRelevance'
  import NoneContent from './NoneContent'
  import moment from 'moment'
  import api from "@/api";

  export default {
    name: 'leftSection',
    components: {
      ObTable,
      ObTabs,
      FieldRelevance,
      NoneContent
    },
    computed: {
      modifiedColumns: ({ columns, selectedTab }) => {
        let modified = [...columns];
        if (selectedTab.type === 'archive') {
          modified = modified.filter(column => column.key !== 'relevance');
          modified = modified.concat([
            {
              title: 'Выполнено',
              key: 'executed_at',
              exactWidth: '100px',
              sort: 'datetime',
              html (data) {
                return `
                  <div class="task-monitor-date">
                    <div>${moment(data.executed_at).locale('ru').format('L')}</div>
                    <div class="task-monitor-date-gray">${moment(data.executed_at).locale('ru').format('LT')}</div>
                  </div>
                `
              }
            },
            {
              title: 'Сотрудник',
              key: 'worker_fio',
              exactWidth: '100px'
            }
          ])
        }

        return modified;
      }
    },
    data () {
      return {
        api,
        isLoading: false,
        tabs: [
          {
            title: 'Актуальные задачи',
            type: 'active'
          },
          {
            title: 'Архив задач',
            type: 'archive'
          },
        ],
        selectedTab: {},
        columns: [
          {
            title: 'Код задачи',
            key: 'code',
            exactWidth: '120px',
            html: data => this.getExpiredStyleValue(data.relevance, data.status, data.code)
          },
          {
            title: 'Задача',
            key: 'type_title',
            html: data => {
              
              if (data.speciesName || data.regNumber) {
                return this.getExpiredStyleValue(data.relevance, data.status, (
                  data.type_title +
                  (data.speciesName ? ': ' + data.speciesName : '') +
                  (data.regNumber ? ', ' + data.regNumber : '')
                ))
              } else {
                return this.getExpiredStyleValue(data.relevance, data.status, (
                  data.type_title +
                  (data.participant_title ? ', ' + data.participant_title : '')
                ))
              }
            }
          },
          {
            title: 'Срок выполнения',
            key: 'relevance',
            exactWidth: '120px',
            slotName: 'relevance'
          },
          {
            title: 'Получено',
            key: 'created_at',
            exactWidth: '100px',
            sort: 'datetime',
            html (data) {
              return `
                <div class="task-monitor-date">
                  <div>${moment(data.created_at).locale('ru').format('L')}</div>
                  <div class="task-monitor-date-gray">${moment(data.created_at).locale('ru').format('LT')}</div>
                </div>
              `
            }
          }
        ]
      }
    },
    created() {
      this.selectedTab = this.tabs[0];
    },
    methods: {
      selectFirstAvailableTask() {
        const firstTask = this.$refs['tasksTable'].currentItems[0];

        if (firstTask) {
          this.onSelect(firstTask.item);
          firstTask._isSelected = true;
        }
      },

      loadTasks(init = false) {
        this.$nextTick(() => {
          this.$refs['tasksTable'].loadData({ init });
        })
      },

      getExpiredStyleValue(relevance, status, value) {
        return relevance < 0 && status.toLowerCase() !== 'executed' ? `<div class="task-monitor-expired-red">${value}</div>` : value;
      },

      // 👂 Events

      onSelect(element) {
        this.$emit('onSelect', element)
      },

      onTableDataLoaded() {
        this.isLoading = false;
        this.$nextTick(() => {
          this.selectFirstAvailableTask();
        })
        this.$emit('loadReady');
      },

      onChangeTab() {
        this.isLoading = true;
      }

    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  ::v-deep {

    .ob-tabs__panel {
      box-shadow: 0 4px 16px rgba($cobalt, .2);
      padding: 10px 20px 0;
      position: relative;
      z-index: 1;
    }

    .table-data {
      min-width: auto;
    }

    .task-monitor-date {
      @include font-mixin(14px, 20px, 400);
    }

    .task-monitor-date-gray {
      color: $color-grey-span;
    }

    .task-monitor-expired-red {
      color: $color-error;
    }
  }

  .task-monitor-relevance-date {
    display: grid; // To break overdue dates
    grid-template-columns: max-content; // To prevent breaking of the long phrases
  }

</style>
